* ------------------------------------------------
* Problem Set Solution: IIP and BoP data
* ------------------------------------------------
*Clean the raw BoP data (bulk download from IMF Website)
import delimited "$raw/BOP_timeseries_annual/BOP_08-14-2020 17-26-54-89_timeSeries.csv", varnames(nonames) clear
rename v1 country_name
rename v2 country_code_num
rename v3 indicator_name
rename v4 indicator_code
rename v5 attribute

foreach x of varlist v* {
	cap {
	local temp=`x'[1]
	rename `x' value`temp'
	}
	cap drop `x' 
}
drop if _n==1
destring country_code_num, replace
*Convert country codes
mmerge country_code_num using "$raw/code_list.dta", umatch(ifscode) ukeep(wbcode)
keep if _merge==3
drop _merge
order wbcode
rename wbcode iso_country_code

keep if regexm(indicator_code,"BP6_USD")==1
replace indicator_code=subinstr(indicator_code,"_BP6_USD","",.)

gen keep=0
foreach x of global iip_keeplist {
	replace keep=1 if indicator_code=="`x'"
}	
keep if keep==1
drop keep
foreach x of varlist value* { 
	destring `x', force replace
}	
reshape long value, i(country_name country_code_num indicator_name indicator_code attribute iso_co) j(year) str
drop if attribute=="Official BPM6"
destring value, replace

drop indicator_name country* attribute
replace value=value/(10^9)
rename value v_
gen length=length(indicator_code)
drop if length>28
drop length

reshape wide v_, i(year iso_co) j(indicator_code) str
renpfix v_
destring year, replace
save "$inter/imf_long_y.dta", replace

*Sum up IIP positions by year
use "$inter/imf_long_y.dta", clear
*I is NIIP
*IA is gross foreign assets
*IL is gross foreign liabilities
collapse (sum) I IA IL, by(year)
keep if year<=2019
gen gap=IA-IL
twoway  (line gap year), ytitle("Global Net International Investment Position, USD Billion") xtitle("") graphregion(color(white))
graph export "$results/global_niip.eps", replace

*Exercise 1b
*Access Table 8 via the IMF CPIS website
